
Redmine - Patch #14318

Watchers Alerted To Changes But Cannot See Issues (potentially)

2013-06-19 22:13 - Brett Patterson

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Issues permissions Estimated time: 0.00 hour

Target version:    

Description

At our company we try to keep things private so user A cannot see tickets from user B.  With this in mind, I set the Issues Visibility

setting for all user groups to be the assigned to or created by me value.  This has the draw back that if I add a watcher because it

may not directly implicate that person but they need to be kept in the loop (e.g. supervisor/boss), they would get the email updates

but can't see the issue within Redmine itself.

So I added two more options to the Issue Visibility dropdown:

1. Created by, Assigned to, or watched by the user

2. Created by, Assigned to, watched by, or contributed to by the user

The contributed to just looks at the journals of the issues to see if you've modified the issue in some way (meaning you now have a

vested interest in the issue).

Attached is the patch I developed against the core of 2.2.3.  I haven't tested it in the 3.x line yet, but hope to soon.

Hopefully this could be wrapped into 2.2.5 or the next 3.x release.

Related issues:

Related to Redmine - Patch #23546: Issue visibility "watched by, created by o... New

Is duplicate of Redmine - Feature #8488: Create an 'Involve' mechanism to pri... New

History

#1 - 2013-06-20 10:12 - Jan Niggemann (redmine.org team member)

Good idea, thank you for your patch!

#2 - 2013-08-21 21:49 - Brett Patterson

I've sent this patch in as a pull request to the github repo.  The patch above should work on the 2.3.x branch.  The only difference are line numbers

might be off slightly.

https://github.com/redmine/redmine/pull/15

I know github isn't the official way, but I'm still hopeful this will be integrated.

#3 - 2013-12-17 14:21 - Brett Patterson

callesg tested with 2.4.1-devel and said it works.  I'm working on testing it as well.

#4 - 2013-12-18 14:59 - Brett Patterson

I can confirm the patch works with 2.4.1.  I manually did the patching, but the same changes do work.

#5 - 2014-05-02 15:27 - Brett Patterson

Jean-Baptiste Barth closed the pull request on GitHub; however, no note here even though I referenced the ticket on GitHub.  The patch is attached

to the original ticket.  Please consider merging this in with the next release.

#6 - 2014-07-02 09:08 - Toshi MARUYAMA

- Related to Defect #17071: Adding Watchers UX Is Not Clean added

#7 - 2016-01-16 06:40 - Go MAEDA

- Target version set to Candidate for next major release
Wonderful feature. I really want to see this in 3.3 relase.

Updated the patch for Redmine 3.2.0.devel.15058. Works fine for me. All that remains is to add tests.

#8 - 2016-01-16 07:06 - Go MAEDA

- File roles-edit.png added

Here is a screenshot.

 

#9 - 2016-01-16 07:14 - Go MAEDA

- Related to Feature #16845: Add permission rule to allow watchers can edit issues added

#10 - 2016-01-16 07:24 - Go MAEDA

- Has duplicate Feature #20106: Adding issue watchers to "Issues Visibility" permissions added

#11 - 2016-01-16 07:32 - Go MAEDA

- Has duplicate Feature #13828: when users can only see their own issues; give watchers the ability to view issues they watch added

#12 - 2016-02-03 03:33 - Hang Xie

patch to Redmine 3.2.0, work fine!

it's better than the patch of #8488

#13 - 2016-02-04 11:37 - Emrah KAVUN

Go MAEDA wrote:

Updated the patch for Redmine 3.2.0.devel.15058. Works fine for me. All that remains is to add tests.

 Are we able to get the updated version somewhere?

Thanks

#14 - 2016-02-04 14:31 - Go MAEDA

- File allow_watchers_and_contributers_access_to_issues_v2.patch added

Emrah KAVUN wrote:

Go MAEDA wrote:

Updated the patch for Redmine 3.2.0.devel.15058. Works fine for me. All that remains is to add tests.

 Are we able to get the updated version somewhere?

Thanks

 Sorry, I forgot to attach the file.

Submitting again: allow_watchers_and_contributers_access_to_issues_v2.patch

#15 - 2016-02-28 04:43 - Toshi MARUYAMA

- Related to Feature #21909: Issues visibility in roles: Issues where user is a watcher added
#16 - 2016-02-28 04:44 - Toshi MARUYAMA

- Related to deleted (Feature #21909: Issues visibility in roles: Issues where user is a watcher)

#17 - 2016-03-21 07:02 - Go MAEDA

- Has duplicate Feature #8858: Extend new issue visibility criteria: issues created by or assigned to the user added

#18 - 2016-03-29 04:14 - Takenori TAKAKI

- File allow_watchers_and_contributers_access_to_issues_trunk_r15287.patch added

Go MAEDA wrote:

Wonderful feature. I really want to see this in 3.3 relase.

Updated the patch for Redmine 3.2.0.devel.15058. Works fine for me. All that remains is to add tests.

I have updated the patch for below:

Compatible with latest trunk (r15287)

Added tests

I also really want to see this in 3.3 relase.

#19 - 2016-03-29 20:09 - Fernando Hartmann

Takenori TAKAKI wrote:

I also really want to see this in 3.3 relase.

 +1

#20 - 2016-03-30 06:24 - Vedat Kamer

Fernando Hartmann wrote:

Takenori TAKAKI wrote:

I also really want to see this in 3.3 relase.

 +1

 +1

#21 - 2016-03-31 11:17 - Go MAEDA

- Target version changed from Candidate for next major release to 3.3.0

Takenori TAKAKI wrote:

I have updated the patch for below:

Compatible with latest trunk (r15287)

Added tests

 Thanks for adding tests!

The patch works fine and passed all tests. I think we can merge this patch. Setting target version to 3.3.0.

#22 - 2016-04-06 23:38 - Fabrizio Sebastiani

- File allow_watchers_and_contributers_access_to_issues_3.2.0.patch added

I tested right now a patch derived from Takenori TAKAKI's one allow_watchers_and_contributers_access_to_issues_trunk_r15287.patch

but since i have a 2.3.0 stable, I have arranged it and I provide it here as allow_watchers_and_contributers_access_to_issues_3.2.0.patch it have

some little differences.

apply it with -p1 to avoid errors:

# cd /my/redmine/root/dir/2.3.0-stable
# ls -d vendor app extra lib bin config README.rdoc 

app  bin  config  extra  lib  README.rdoc  vendor

# patch -p1 < /somewhere/allow_watchers_and_contributers_access_to_issues_3.2.0.patch

 I didn't run test functions, sorry.

Thank you for this patch and candidate for next release. We are getting a good experience with redmine as a new tool in company: this functionality is

absolutely important for us.

#23 - 2016-05-08 09:11 - Jean-Philippe Lang

- Status changed from New to Closed

- Target version deleted (3.3.0)

This is the same as #8488. Using watchers as a way to give access to issues was already discussed, please see #7412#note-13.

#24 - 2016-05-08 09:13 - Jean-Philippe Lang

- Related to deleted (Feature #16845: Add permission rule to allow watchers can edit issues)

#25 - 2016-05-08 09:13 - Jean-Philippe Lang

- Has duplicate deleted (Feature #13828: when users can only see their own issues; give watchers the ability to view issues they watch)

#26 - 2016-05-08 09:13 - Jean-Philippe Lang

- Has duplicate deleted (Feature #20106: Adding issue watchers to "Issues Visibility" permissions)

#27 - 2016-05-08 09:13 - Jean-Philippe Lang

- Has duplicate deleted (Feature #8858: Extend new issue visibility criteria: issues created by or assigned to the user)

#28 - 2016-05-08 09:13 - Jean-Philippe Lang

- Related to deleted (Defect #17071: Adding Watchers UX Is Not Clean)

#29 - 2016-05-08 09:13 - Jean-Philippe Lang

- Related to Feature #8488: Create an 'Involve' mechanism to private issues added

#30 - 2016-05-08 09:14 - Jean-Philippe Lang

- Related to deleted (Feature #8488: Create an 'Involve' mechanism to private issues)

#31 - 2016-05-08 09:14 - Jean-Philippe Lang

- Is duplicate of Feature #8488: Create an 'Involve' mechanism to private issues added

#32 - 2016-06-07 14:31 - Tobias Fischer

There's ongoing discussion in #8488.

But for those landing here in this ticket I can confirm allow_watchers_and_contributers_access_to_issues_3.2.0.patch works well for

3.2.3.stable.15464

#33 - 2016-08-09 09:30 - Jan from Planio www.plan.io

- Related to Patch #23546: Issue visibility "watched by, created by or assigned to" for roles added

#34 - 2017-01-26 01:19 - Peter Brogren

We agree that this is functionality that should get merged in, as soon as possible. On the subject of confusing, we believe it is very confusing for

someone to get the notification as a watcher but then not be able to log in and see the issue. We do use a modified patch of this and frequently use

the method of adding someone as a watcher as a way to allow ("invite") someone to see what happens with a certain private (secret!) issue, i.e. get

the email notifications AND be able to log in and see the issue. If such person then decides to "unwatch" the issue, it seems OK with everyone that

you no longer get the emails AND are no longer able to see the issue. After all you decided to "unwatch" the issue, i.e. you specifically said you don't

want to see (watch) it anymore! Please merge at the earliest convenience!

#35 - 2017-08-08 16:24 - Tobias Fischer

- File allow_watchers_and_contributers_access_to_issues_3.3.0.patch added

The attached patch is an updated version of allow_watchers_and_contributers_access_to_issues_3.2.0.patch which works for 3.3.x

Needs to be run from redmine install root dir.
#36 - 2017-08-08 17:17 - Tobias Fischer

- File allow_watchers_and_contributers_access_to_issues_3.4.2.patch added

And this patch was made against Redmine 3.4.2 and I can confirm it works.

#37 - 2017-12-28 09:12 - Lara R

Tobias Fischer wrote:

And this patch was made against Redmine 3.4.2 and I can confirm it works.

 And in which directory did you install it? I am unable to install it.

I got this error:

can't find file to patch at input line 4_ Perhaps you used the wrong -p or --strip option? The text leading up to this was:

|*** diff -Naur app/models/issue.rb ----- File to patch: –

#38 - 2017-12-28 23:51 - Tobias Fischer

I'm not sure, this has been a while.

But visiting my .bash_history file showed me this:

cp 14318-allow_watchers_and_contributers_access_to_issues_3.4.2.patch redmine-3.4/

cd redmine-3.4/

patch -p0 --dry-run < 14318-allow_watchers_and_contributers_access_to_issues_3.4.2.patch

patch -p0 < 14318-allow_watchers_and_contributers_access_to_issues_3.4.2.patch

 So looks like I installed it from the redmine root directory and first tried it with a dry-run.

#39 - 2018-04-28 16:23 - Lara R

Tobias Fischer wrote:

I'm not sure, this has been a while.

But visiting my .bash_history file showed me this:

[...]

So looks like I installed it from the redmine root directory and first tried it with a dry-run.

 I tried with those commands but still getting the same error.

Any ideas?

#40 - 2018-05-25 23:54 - Mitchell Fang

+1  Thanks! able to use the 3.4.2 patch on 3.4.4.stable.17206

thanks a bunch

imane seddiki R

Are you sure you are at the root redmine directory?  that depends on where redmine was installed.

#41 - 2018-07-23 11:28 - froot wang

+1 Thanks! able to use the 3.4.2 patch on 3.4.6

if use bitnami redmine,should cd htdoc then use patch -p0 cmd.

#42 - 2018-08-30 15:21 - Ivan Kotelnikov

Redmine version   3.4.6

patch -p0 did not work

I have added all changes manually

it works!

Thanks!

#43 - 2018-09-07 10:07 - Eric Feyzullov

3.4.2 patch nice work on 3.4.6. thank you so much
root@66300:/var/www/redmine# patch -p0 < allow_watchers_and_contributers_access_to_issues_3.4.2.diff

patching file app/models/issue.rb

Hunk #1 succeeded at 130 (offset -2 lines).

Hunk #2 succeeded at 165 (offset -2 lines).

patching file app/models/role.rb

patching file config/locales/en.yml

patching file test/unit/issue_test.rb

#44 - 2019-01-08 14:21 - Kicking Alderman

- File allow_watchers_and_contributers_access_to_issues_4.0.0.patch added

- File watchers.png added

Awesome work!

Testing Redmine 4.0 right now, and this patch is something we could really use.

The patch worked, but with a couple of minor changes.

First, in the issue.rb file user.groups.map(&:id) should be user.groups.pluck(:id).

Second, there are a couple of line number mismatches, but that can be easily fixed using fuzz:

superuser@redmineserver:/srv/git/redmine$ patch -p0 -F3 < allow_watchers_and_contributers_access_to_issues_4.0

.0.patch

patching file app/models/issue.rb

Hunk #1 succeeded at 129 (offset -3 lines).

Hunk #2 succeeded at 164 (offset -3 lines).

patching file app/models/role.rb

patching file config/locales/en.yml

Hunk #1 succeeded at 462 with fuzz 3.

Hunk #2 succeeded at 1020 with fuzz 3.

patching file test/unit/issue_test.rb

#45 - 2019-02-22 16:09 - Jacq Jacq

- File allow_watchers_and_contributers_access_to_issues_4.0.2.patch added

Testing in Redmine 4.0.2, attached line number mismatches.

#46 - 2019-04-04 10:53 - SOE Redmine

Hi!

Do you have any updated information about the patch in 4.0.2? I would like to install it and try.

Is this the right way i can install it?: patch -p0 -F3 < filename?

Can I uninstall this patch if i needed?

Does this patch effect the further redmine upgrade process?

Do you find any bug related to this patch?

Thanks,

#47 - 2019-04-04 13:18 - SOE Redmine

Please add it as plugin!

#48 - 2019-08-08 13:07 - Taner Tas

Can we extend this patch for private projects too?

This patch seems work only on public projects.

#49 - 2019-08-28 20:52 - Luciano Fantuzzi

+1 to Taner request. All our projects structure is private and this patch works but only applies to public projects. Any chance someone can tell how to

make it work also for private projects?

Thank you.

#50 - 2019-10-11 10:13 - Eric Feyzullov

working well with manually add on 4.0.4.stable.18380

thank you

#51 - 2020-02-17 14:23 - Jacq Jacq

- File allow_watchers_and_contributers_access_to_issues_4.1.0.patch added
Testing in Redmine 4.1.0, attached line number mismatches.

#52 - 2020-03-03 09:16 - Jonathan Griffon

- File allow_watchers_and_contributers_access_to_issues_4.1.0.patch added

Jacq Jacq wrote:

Testing in Redmine 4.1.0, attached line number mismatches.

 this one is working for 4.1.0

#53 - 2020-04-07 15:58 - Aleksandar Pavic

This should be part of core functionality...

+1

#54 - 2020-06-02 19:19 - Jobin @ RedminePRO

Working on 4.1.1 ?

#55 - 2020-09-25 11:15 - Jej Jerome

I have issue with it on 4.1.1

Users have 403 error on all issues.

They see issue in issue list, but when they click on it, it's forbidden.

My patch didn't applied correctly. I manually add missing lines and it works well in 4.1.1

#56 - 2021-05-10 19:25 - Frederico Camara

- File 0001-Fix-query-error-where-no-issue_ids-are-watched-or-fo.patch added

Postgres returns an error:

ActiveRecord::StatementInvalid (PG::SyntaxError: ERROR: syntax error at or near ")" LINE 1: ...es.assigned_to_

id IN (10,111) OR issues.id IN ()))) OR (p...

 It seems it does not accept the empty list "issues.id IN ()".

I added some code to fix it, here's the patch. To be applied over your patch:

git -am 0001-Fix-query-error-where-no-issue_ids-are-watched-or-fo.patch

#57 - 2021-09-26 00:04 - Jobin @ RedminePRO

- File allow_watchers_and_contributers_access_to_issues_4.2.2.patch added

Here is the patch for Redmine 4.2.2

Apply with the below commands.

cd redmine

patch -p1 < allow_watchers_and_contributers_access_to_issues_4.2.2.patch

#58 - 2021-11-17 16:54 - Jonathan Griffon

- File 0002-modif-watchers.patch added

due to  Patch #3329 and new Feature #4511, list of users in Add watcher button does not list potential watchers.

Patch need to check if Issues Visibility is defined as "watched by the user" in all user list

It's only for version 4.2.x

I think problem is under app/models/principal.rb with a new class assignable_watchers which is filtering users but I don't understand how.

I'm sure this is this class because of change in app/controlers/watchers_controller.rb in function users_for_new_watcher old versions list users with 

@project.users and now it's with @project.principals.assignable_watchers
I worked around the problem by resetting the call to the list of all users in watchers_controller.rb but the groups functionality no longer works (see my

patch in attached file)

#59 - 2021-11-29 16:33 - Rolf Wojtech

I can confirm Jonathan's issue with the 4.2.2 patch. I have not tried his workaround yet.

Maybe it is time to migrate away from the somewhat dirty patching towards this plugin:

https://github.com/maxrossello/redmine_extended_watchers

(found in #8488)

Has anyone done this step already and experiences to share here?

#60 - 2021-11-30 13:07 - Jonathan Griffon

Rolf Wojtech wrote:

I can confirm Jonathan's issue with the 4.2.2 patch. I have not tried his workaround yet.

Maybe it is time to migrate away from the somewhat dirty patching towards this plugin:

https://github.com/maxrossello/redmine_extended_watchers

(found in #8488)

Has anyone done this step already and experiences to share here?

 I tried this plugin and it work well

Thank you

#61 - 2022-05-09 13:21 - Aleksandar Pavic

Go MAEDA wrote:

Here is a screenshot.

 

 +1

This ticket should not be closed...

This should be implemented in core.

#62 - 2023-03-06 09:00 - Sofie vdm

Aleksandar Pavic wrote:

This ticket should not be closed...

This should be implemented in core.

 +1

#63 - 2023-11-29 11:05 - Gal Ito

Hello. Would it be possible to have a fully compatible release for Redmine 5.1.1 please ?

#64 - 2023-12-14 12:49 - Rasko R

Hello guys.
Could you add this feature for latest Redmine 5 version please?

Thanks in advance.

#65 - 2024-10-29 14:09 - Stefan Mueller

Hello,

I agree with the previous user.

We also need this behavior or plugin.

Would it be possible to integrate this into Redmine?

Is this plugin compatible with 5.x?

Thanks in advance.

Files

allow_watchers_and_contributers_access_to_issues.patch 3.31 KB 2013-06-19 Brett Patterson

roles-edit.png 35.9 KB 2016-01-16 Go MAEDA

allow_watchers_and_contributers_access_to_issues_v2.patch 3.28 KB 2016-02-04 Go MAEDA

allow_watchers_and_contributers_access_to_issues_trunk_r15287.patch7.4 KB 2016-03-29 Takenori TAKAKI

allow_watchers_and_contributers_access_to_issues_3.2.0.patch 7.43 KB 2016-04-06 Fabrizio Sebastiani

allow_watchers_and_contributers_access_to_issues_3.3.0.patch 7.41 KB 2017-08-08 Tobias Fischer

allow_watchers_and_contributers_access_to_issues_3.4.2.patch 7.47 KB 2017-08-08 Tobias Fischer

allow_watchers_and_contributers_access_to_issues_4.0.0.patch 7.48 KB 2019-01-08 Kicking Alderman

watchers.png 8.29 KB 2019-01-08 Kicking Alderman

allow_watchers_and_contributers_access_to_issues_4.0.2.patch 7.74 KB 2019-02-22 Jacq Jacq

allow_watchers_and_contributers_access_to_issues_4.1.0.patch 7.61 KB 2020-02-17 Jacq Jacq

allow_watchers_and_contributers_access_to_issues_4.1.0.patch 8.35 KB 2020-03-03 Jonathan Griffon

0001-Fix-query-error-where-no-issue_ids-are-watched-or-fo.patch 2.29 KB 2021-05-10 Frederico Camara

allow_watchers_and_contributers_access_to_issues_4.2.2.patch 7.99 KB 2021-09-25 Jobin @ RedminePRO

0002-modif-watchers.patch 1.14 KB 2021-11-17 Jonathan Griffon

Powered by TCPDF (www.tcpdf.org)

2025-05-02 9/9

http://www.tcpdf.org

